#!/usr/bin/env python
# -*- coding: utf-8 -*-

import urllib, re , loadyouporn, os
from threadpool import *

class PussyPlace(loadyouporn.LoadYouPorn):
          
    

    def start(self):
        base1URL="http://xxxporn.cn/view.php?start_from="
        base2URL="&ucat=&archive=&subaction=&id=&do=index"
        linkPattern="http://[\w/_=;&\?.]*.wmv"
        start_from=0
        increment=15
        pages=[]
#        self.maxpages=1
        
        # now start the threadpool
        # we create a pool of numThread worker threads
        if self.verbose:
            print "Initializing ThreadPool of size:",self.numThreads
        main = ThreadPool(self.numThreads)
        
        # we do that twice because of session timeout
        for i in range(0,2):
            if i==1:
                if self.verbose:
                    print "rescanning sites to compensate for timeouts"
                    start_from=0
                    increment=15
            if self.maxpages==-1:
                self.maxpages=99999
            while True and start_from<increment*self.maxpages:
                baseURL=base1URL+str(start_from)+base2URL
                links=[]
                try:
                    if self.verbose:
                        print "fetching:",baseURL
                    html=self.fetchpage(baseURL)
                    links=self.searchlinks(html, linkPattern)
                    start_from=start_from+increment
                    print "fetching done",baseURL
                except IOError: # 400+ error
                    print "No further pages or network down ", baseURL
                    break
                if self.verbose:
                    print "video pages to check for page : ",str(len(links))
    
                allfiles=[]
                for page in set(links):
                    
                    if self.verbose:
                        print "looking for files in: " + page  
                    try:
                        html=self.fetchpage(page)
                        url=self.searchfiles(html)
                        if not url == None:
                            allfiles.append(url)
                    except:
                        print "Problems finding files ! Site down ?"
                print "Files to download:",len(allfiles)
                
                #Now start the threads for
                # assemble the arguments for each job to a list...
                data = allfiles
                # ... and build a WorkRequest object for each item in data
                requests = makeRequests(self.downloadFile, data, self.print_result, self.handle_exception)
                # then we put the work requests in the queue...
                [main.putRequest(req) for req in requests]
                # ...and wait for the results to arrive in the result queue
                main.wait()
        
    
    def searchfiles(self,html):
        wmvPattern="http://[0-9.]*/dl[\w/]*video/[\w_.]*.wmv"
        p = re.compile(wmvPattern)
        m=p.search(html)
        if m==None:
            return
        url = m.group()
        filename=self.getFileName(url)#url[url.rfind("/")+1:]
        if self.verbose:
            print "found file:",filename,"at:",url
        if not os.path.exists(filename) or self.overwrite==True:
            return url
        else:
            if self.verbose:
                print "file already exists:",filename
        return None
    
        